<template>
    <div>
        <div
            class="uk-inline jeu"
            v-bind:style="{ width: size + 'px', height: size + 'px' }"
        >
            <div :id="boardName" class="board-libertes" />
            <Resultat
                :afficher="exoValide"
                :texteHaut="'Réussi !'"
                :avecErreur="enErreur"
                :texteBas="messageErreur"
                @reinitialiserProbleme="reinitialiser"
            />
        </div>
    </div>
</template>

<script lang="ts">
import Goban from '@/components/goban/GobanProbleme.vue';
import Resultat from '@/components/jeu/Resultat.vue';
import Component, { mixins } from 'vue-class-component';
import { Prop } from 'vue-property-decorator';

@Component({
    components: { Resultat }
})
export default class GobanLibertes extends mixins(Goban) {
    @Prop() solution: any[];

    private _croixRouge: any = {};

    compteurLibertes = 1;
    compteurSolution = 0;
    compteurErreur = 0;

    get messageErreur() {
        const erreur = this.compteurErreur > 1 ? ' erreurs' : ' erreur';
        return 'Avec ' + this.compteurErreur + erreur;
    }

    created() {
        this._croixRouge = {
            stone: {
                draw: function(args, board) {
                    const xr = board.getX(args.x),
                        yr = board.getY(args.y),
                        sr = board.stoneRadius,
                        prc = 0.4;
                    this.strokeStyle = 'red';

                    this.lineWidth = 8;

                    this.beginPath();

                    this.moveTo(xr - sr * prc, yr - sr * prc);
                    this.lineTo(xr + sr * prc, yr + sr * prc);
                    this.moveTo(xr + sr * prc, yr - sr * prc);
                    this.lineTo(xr - sr * prc, yr + sr * prc);
                    this.stroke();
                }
            }
        };
    }

    getListener() {
        return (x, y) => {
            if (this.game.isValid(x, y) && !this.exoValide) {
                if (this.isSolution(x, y)) {
                    this.actionQuandVrai(x, y);
                } else {
                    this.actionQuandFaux(x, y);
                }
                this.game.play(x, y);
            }
        };
    }

    isSolution(x, y) {
        return this.solution.some(
            element => element.abscisse == x && element.ordonnee == y
        );
    }

    actionQuandVrai(x, y) {
        this.ajouterTexte(x, y, this.compteurLibertes);
        this.compteurLibertes += 1;
        this.compteurSolution++;
        this.verifierCompteur();
    }

    actionQuandFaux(x, y) {
        this.board.addObject({
            x: x,
            y: y,
            type: this._croixRouge
        });
        this.compteurErreur++;
    }

    verifierCompteur() {
        this.exoValide = this.compteurSolution === this.solution.length;
        if (this.compteurErreur > 0) {
            this.enErreur = true;
        }
        if (this.exoValide) {
            this.$emit('envoyerResultat', !this.enErreur);
        }
    }

    reinitialiser() {
        this.compteurLibertes = 1;
        this.compteurSolution = 0;
        this.compteurErreur = 0;
        this.exoValide = false;
        this.enErreur = false;
        this.board.removeAllObjects();
        this.setGame();
        this.afficherSituationInitiale();
        this.afficherMarqueursInitiaux();
    }
}
</script>

<style>
.jeu {
    position: relative;
}
.board-libertes {
    position: absolute;
    z-index: 0;
}
</style>
